diff --git a/include/hexdump.h b/include/hexdump.h
index f2ca4793d699..390af4c8da1e 100644
--- a/include/hexdump.h
+++ b/include/hexdump.h
@@ -147,6 +147,8 @@ int hex_dump_to_buffer(const void *buf, size_t len, int rowsize, int groupsize,
  */
 int print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
 		   int groupsize, const void *buf, size_t len, bool ascii);
+int debug_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
+		   int groupsize, const void *buf, size_t len, bool ascii);
 
 /**
  * print_hex_dump_bytes - shorthand form of print_hex_dump() with default params
@@ -162,5 +164,7 @@ int print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
  */
 void print_hex_dump_bytes(const char *prefix_str, int prefix_type,
 			  const void *buf, size_t len);
+void debug_hex_dump_bytes(const char *prefix_str, int prefix_type,
+			  const void *buf, size_t len);
 
 #endif /* HEXDUMP_H */
diff --git a/lib/hexdump.c b/lib/hexdump.c
index 149c93ead8b8..39c9e86649a0 100644
--- a/lib/hexdump.c
+++ b/lib/hexdump.c
@@ -125,8 +125,9 @@ overflow1:
 	return ascii ? ascii_column + len : (groupsize * 2 + 1) * ngroups - 1;
 }
 
-int print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
-		   int groupsize, const void *buf, size_t len, bool ascii)
+static int do_print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
+			     int groupsize, const void *buf, size_t len, bool ascii,
+			     bool dbg)
 {
 	const u8 *ptr = buf;
 	int i, linelen, remaining = len;
@@ -146,15 +147,27 @@ int print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
 
 		switch (prefix_type) {
 		case DUMP_PREFIX_ADDRESS:
-			printf("%s%0*lx: %s\n", prefix_str,
-			       IS_ENABLED(CONFIG_PHYS_64BIT) ? 16 : 8,
-			       (ulong)map_to_sysmem(ptr) + i, linebuf);
+			if (dbg) {
+				debug("%s%0*lx: %s\n", prefix_str,
+				      IS_ENABLED(CONFIG_PHYS_64BIT) ? 16 : 8,
+				      (ulong)map_to_sysmem(ptr) + i, linebuf);
+			} else }
+				printf("%s%0*lx: %s\n", prefix_str,
+				       IS_ENABLED(CONFIG_PHYS_64BIT) ? 16 : 8,
+				       (ulong)map_to_sysmem(ptr) + i, linebuf);
+			}
 			break;
 		case DUMP_PREFIX_OFFSET:
-			printf("%s%.8x: %s\n", prefix_str, i, linebuf);
+			if (dbg)
+				debug("%s%.8x: %s\n", prefix_str, i, linebuf);
+			else
+				printf("%s%.8x: %s\n", prefix_str, i, linebuf);
 			break;
 		default:
-			printf("%s%s\n", prefix_str, linebuf);
+			if (dbg)
+				debug("%s%s\n", prefix_str, linebuf);
+			else
+				printf("%s%s\n", prefix_str, linebuf);
 			break;
 		}
 		if (!IS_ENABLED(CONFIG_SPL_BUILD) && ctrlc())
@@ -164,10 +177,30 @@ int print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
 	return 0;
 }
 
+int print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
+		   int groupsize, const void *buf, size_t len, bool ascii)
+{
+	return do_print_hex_dump(prefix_str, prefix_type, rowsize, groupsize,
+				 buf, len, ascii, false);
+}
+
+int debug_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
+		   int groupsize, const void *buf, size_t len, bool ascii)
+{
+	return do_print_hex_dump(prefix_str, prefix_type, rowsize, groupsize,
+				 buf, len, ascii, true);
+}
+
 void print_hex_dump_bytes(const char *prefix_str, int prefix_type,
 			  const void *buf, size_t len)
 {
-	print_hex_dump(prefix_str, prefix_type, 16, 1, buf, len, true);
+	do_print_hex_dump(prefix_str, prefix_type, 16, 1, buf, len, true, false);
+}
+
+void debug_hex_dump_bytes(const char *prefix_str, int prefix_type,
+			  const void *buf, size_t len)
+{
+	do_print_hex_dump(prefix_str, prefix_type, 16, 1, buf, len, true, true);
 }
 #else
 /*
@@ -180,8 +213,19 @@ int print_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
 	return -ENOSYS;
 }
 
+int debug_hex_dump(const char *prefix_str, int prefix_type, int rowsize,
+		   int groupsize, const void *buf, size_t len, bool ascii)
+{
+	return -ENOSYS;
+}
+
 void print_hex_dump_bytes(const char *prefix_str, int prefix_type,
 			  const void *buf, size_t len)
 {
 }
+
+void debug_hex_dump_bytes(const char *prefix_str, int prefix_type,
+			  const void *buf, size_t len)
+{
+}
 #endif /* CONFIG_HEXDUMP */